#class ASN1Token;
package ASN1Token;

use strict;

#token type constants (pretend this is an enum :)
sub TOKEN         { 0; }
sub BLOCK_COMMENT { 1; }
sub EOL_COMMENT   { 2; }

#constructor
sub new {
    my $invocant = shift; #the first arg is the class
    my $class = ref($invocant) || $invocant;
    my $self = {
        line      => undef,  # the token's line number in the source file
        type      => undef,  # token type (see constants at top of file)
        string    => undef,  # token string
        @_,
    };
    bless $self, $class;
    return $self;
}


sub debugprint {
    my ($ob) = @_;
    print "ASN1Token: [".$ob->{line}." ".$ob->{type}." ";

    if( $ob->{type} != BLOCK_COMMENT )  { print $ob->{string};                     }
    else                                { print substr($ob->{string},0,10)."...";  }

    print " ]\n";
}

sub line   { return $_[0]->{line};   }
sub type   { return $_[0]->{type};   }
sub string { return $_[0]->{string}; }




1;
