#class ChoiceContent
package ChoiceContent;

use strict;
use BooleanTF;


#constructor
sub new {
    my $invocant = shift; #the first arg is the class
    my $class = ref($invocant) || $invocant;
    my $self = {
        childnames => [],  # array of child names
        childunames => [], # array of child uniquenames
        childtypes => [],  # array of child types
        block_comments => [],  # array of comments which precede children
        eol_comments => [],  # array of eol comments after children

        tail_comment => undef,
        has_dotdotdot => FALSE
        # no values taken from the constructor!

        # TODO no choice structs have tail comments, so I didn't implement them
    };
    bless $self, $class;
    return $self;
}

sub addChoice($$$$$)
{
    my ($ob,$cname,$cuname,$ctype,$ccom,$ceol) = @_;

    push @{$ob->{childnames}}, $cname;
    push @{$ob->{childunames}}, $cuname;
    push @{$ob->{childtypes}}, $ctype;
    push @{$ob->{block_comments}}, $ccom;
    push @{$ob->{eol_comments}}, $ceol;
}

# =========
# accessors
# =========
sub getChoiceArray($)
{
    my ($ob,$x) = @_;

    if( ($x > $#{$ob->{childnames}}) || ($x < 0) )
    {
        return FALSE;
    }
    
    return [ ${$ob->{childnames}}[$x], 
             ${$ob->{childunames}}[$x],
             ${$ob->{childtypes}}[$x],
             ${$ob->{block_comments}}[$x],
             ${$ob->{eol_comments}}[$x]     ];
}

sub getNumChoices()
{
    return 1+$#{$_[0]->{childnames}}; 
}

#only useful for pretty printing
sub getMaxNameWidth()
{
    my $maxl = 0;
    foreach( @{$_[0]->{childnames}} )
    {
        if( $maxl < length ) { $maxl = length; }
    }
    return $maxl;
}

sub setTailComment($)
{
    my ($ob,$c) = @_;
    $ob->{tail_comment} = $c;
}

sub getTailComment()
{
    if( defined($_[0]->{tail_comment}) )
    {
        return $_[0]->{tail_comment};
    }

    return FALSE;
}


sub setHasDotDotDot($)
{
    my ($ob,$c) = @_;
    $ob->{has_dotdotdot} = $c;
}

sub getHasDotDotDot()
{
    return $_[0]->{has_dotdotdot};
}

1;
