#class DefinitionContent
package DefinitionContent;

use strict;
use BooleanTF;

# WARNING: This class is kind of hacky and quickly-written.
# It's probably okay because definition info is only useful
# for pretty-printing and not code generation.

#constructor
sub new {
    my $invocant = shift; #the first arg is the class
    my $class = ref($invocant) || $invocant;
    my $self = {
        name => "",
        pre_def_comment => "",
        pre_begin_comment => "",
        pre_import_comment => "",

        # This index refers to the global struct array
        # so we know when this def ends and the next begins.
        index_of_last_struct_in_def => undef,

        # these two arrays are aligned on index
        from_array => [],         # names of the "FROM" sources
        from_end_indices => [],   # indices to imported_ie_array,
                                  #   set to index of last ie in the from group

        imp_comment_hash => {},  # key=ie name, value=comment that precedes ie
        
        imported_ie_array => [],
        ie_array => []
        
        # no values taken from the constructor!
    };
    bless $self, $class;
    return $self;
}


#input 1 is string IE name, input 2 (if present) is comment that precedes it
sub addImportedIE($;$)
{
    my ($ob,$ie,$com) = @_;

    push @{$ob->{imported_ie_array}}, $ie;

    if( $com && ($com ne "") )
    {
        ${$ob->{imp_comment_hash}}{$ie} = $com;
    }
}

#input is a string
sub addIE($)
{
    my ($ob,$ie) = @_;

    push @{$ob->{ie_array}}, $ie;    
}

# input is a string
sub addFrom($)
{
    my ($ob,$from) = @_;

    push @{$ob->{from_array}}, $from;
    push @{$ob->{from_end_indices}}, $#{$ob->{imported_ie_array}};
}

# =========
# accessors
# =========

# how many FROM sets are in the def?
sub getNumFroms()
{
    # return size of @from_array
    return scalar( @{$_[0]->{from_array}} );
}

# gets the FROM name associated with the nth FROM set
sub getFromName($)
{
    my ($ob,$n) = @_;
    return ${@{$ob->{from_array}}}[$n];
}

# gets an array of IEs associated with the nth FROM set
sub getImportedIEs($)
{
    my ($ob,$n) = @_;
    my $end = ${@{$ob->{from_end_indices}}}[$n];
    my $start = ($n==0) ? 0 : (${@{$ob->{from_end_indices}}}[$n-1])+1;

    return @{$ob->{imported_ie_array}}[$start..$end];
}

sub getIEs()
{
    return @{$_[0]->{ie_array}};
}

# arg is an ie name
sub getImpIEcomment($)
{
    my ($ob,$ie) = @_;
    return ${%{$ob->{imp_comment_hash}}}{$ie};
}

1;
